Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
Botan::RSA_PrivateKey Class Referenceabstract

`#include <rsa.h>`

Inheritance diagram for Botan::RSA_PrivateKey:

## Public Member Functions
virtual std::string | algo_name () const =0
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
virtual AlgorithmIdentifier | algorithm_identifier () const =0
bool | check_key (RandomNumberGenerator &rng, bool) const override
std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const
virtual size_t | estimated_strength () const =0
size_t | estimated_strength () const override
std::string | fingerprint (const std::string &alg="SHA") const
const BigInt & | get_c () const
const BigInt & | get_d () const
const BigInt & | get_d1 () const
const BigInt & | get_d2 () const
const BigInt & | get_e () const
const BigInt & | get_n () const
virtual OID | get_oid () const
const BigInt & | get_p () const
const BigInt & | get_q () const
virtual size_t | key_length () const =0
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
virtual AlgorithmIdentifier | pkcs8_algorithm_identifier () const
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
std::vector< uint8_t > | public_key_bits () const override
virtual std::vector< uint8_t > | public_key_bits () const =0
| RSA_PrivateKey (const AlgorithmIdentifier &alg_id, const secure_vector< uint8_t > &key_bits)
| RSA_PrivateKey (const BigInt &p, const BigInt &q, const BigInt &e, const BigInt &d=0, const BigInt &n=0)
| RSA_PrivateKey (RandomNumberGenerator &rng, size_t bits, size_t exp=65537)
std::vector< uint8_t > | subject_public_key () const

## Protected Attributes
BigInt | m_e
BigInt | m_n

## Detailed Description

RSA Private Key

Definition at line 82 of file rsa.h.

## Constructor & Destructor Documentation

Botan::RSA_PrivateKey::RSA_PrivateKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const secure_vector< uint8_t > & | key_bits
| ) |  |

Load a private key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | PKCS#1 RSAPrivateKey bits

Definition at line 91 of file rsa.cpp.

References Botan::PEM_Code::decode(), Botan::BER_Decoder::decode_and_check(), Botan::RSA_PublicKey::m_e, Botan::RSA_PublicKey::m_n, Botan::SEQUENCE, and Botan::BER_Decoder::start_cons().

93 {
94 BER_Decoder(key_bits)
95 .start_cons(SEQUENCE)
96 .decode_and_check<size_t>(0, "Unknown PKCS #1 key format version")
97 .decode(m_n)
98 .decode(m_e)
99 .decode(m_d)
100 .decode(m_p)
101 .decode(m_q)
102 .decode(m_d1)
103 .decode(m_d2)
104 .decode(m_c)
105 .end_cons();
106 }
Botan::PEM_Code::decode
secure_vector< uint8_t > decode(DataSource &source, std::string &label)
Definition: pem.cpp:68
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

Botan::RSA_PrivateKey::RSA_PrivateKey | ( | const BigInt & | p,
|  | const BigInt & | q,
|  | const BigInt & | e,
|  | const BigInt & | d = `0`,
|  | const BigInt & | n = `0`
| ) |  |

Construct a private key from the specified parameters.

Parameters

  p | the first prime
  q | the second prime
  e | the exponent
  d | if specified, this has to be d with exp * d = 1 mod (p - 1, q - 1). Leave it as 0 if you wish to the constructor to calculate it.
  n | if specified, this must be n = p * q. Leave it as 0 if you wish to the constructor to calculate it.

Definition at line 108 of file rsa.cpp.

112 :
113 m_d{ d_exp }, m_p{ prime1 }, m_q{ prime2 }, m_d1{}, m_d2{}, m_c{ inverse_mod( m_q, m_p ) }
114 {
115 m_n = mod.is_nonzero() ? mod : m_p * m_q;
116 m_e = exp;
117
118 if(m_d == 0)
119 {
120 BigInt inv_for_d = lcm(m_p - 1, m_q - 1);
121 if(m_e.is_even())
122 inv_for_d >>= 1;
123
124 m_d = inverse_mod(m_e, inv_for_d);
125 }
126
127 m_d1 = m_d % (m_p - 1);
128 m_d2 = m_d % (m_q - 1);
129 }
Botan::BigInt::is_even
bool is_even() const
Definition: bigint.h:232
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::BigInt::is_nonzero
bool is_nonzero() const
Definition: bigint.h:244
Botan::inverse_mod
BigInt inverse_mod(const BigInt &n, const BigInt &mod)
Definition: numthry.cpp:276
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76
Botan::lcm
BigInt lcm(const BigInt &a, const BigInt &b)
Definition: numthry.cpp:73

Botan::RSA_PrivateKey::RSA_PrivateKey | ( | RandomNumberGenerator & | rng,
|  | size_t | bits,
|  | size_t | exp = `65537`
| ) |  |

Create a new private key with the specified bit length

Parameters

  rng | the random number generator to use
  bits | the desired bit length of the private key
  exp | the public exponent to be used

Definition at line 134 of file rsa.cpp.

References Botan::RSA_PublicKey::algo_name(), Botan::BigInt::bits(), Botan::inverse_mod(), Botan::lcm(), Botan::RSA_PublicKey::m_e, Botan::RSA_PublicKey::m_n, Botan::random_prime(), and Botan::ASN1::to_string().

136 {
137 if(bits < 1024)
138 throw Invalid_Argument(algo_name() + ": Can't make a key that is only " +
139 std::to_string(bits) + " bits long");
140 if(exp < 3 || exp % 2 == 0)
141 throw Invalid_Argument(algo_name() + ": Invalid encryption exponent");
142
143 m_e = exp;
144
145 do
146 {
147 m_p = random_prime(rng, (bits + 1) / 2, m_e);
148 m_q = random_prime(rng, bits - m_p.bits(), m_e);
149 m_n = m_p * m_q;
150 } while(m_n.bits() != bits);
151
152 m_d = inverse_mod(m_e, lcm(m_p - 1, m_q - 1));
153 m_d1 = m_d % (m_p - 1);
154 m_d2 = m_d % (m_q - 1);
155 m_c = inverse_mod(m_q, m_p);
156 }
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:47
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:184
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38
Botan::inverse_mod
BigInt inverse_mod(const BigInt &n, const BigInt &mod)
Definition: numthry.cpp:276
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76
Botan::lcm
BigInt lcm(const BigInt &a, const BigInt &b)
Definition: numthry.cpp:73
Botan::random_prime
BigInt random_prime(RandomNumberGenerator &rng, size_t bits, const BigInt &coprime, size_t equiv, size_t modulo)
Definition: make_prm.cpp:17

## Member Function Documentation

virtual std::string Botan::Public_Key::algo_name | ( |  | ) | const
| pure virtual inherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implemented in Botan::XMSS_WOTS_PublicKey, Botan::XMSS_PublicKey, Botan::TPM_PrivateKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::ECDSA_PublicKey, Botan::ECDH_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::RSA_PublicKey, Botan::McEliece_PublicKey, Botan::DH_PublicKey, Botan::DSA_PublicKey, Botan::ElGamal_PublicKey, and Botan::Curve25519_PublicKey.

Referenced by Botan::PKCS8::BER_encode(), Botan::TLS::Policy::check_peer_key_acceptable(), Botan::X509_Object::check_signature(), Botan::TLS::Handshake_State::choose_sig_format(), Botan::choose_sig_format(), Botan::TLS::Client_Key_Exchange::Client_Key_Exchange(), Botan::Private_Key::create_decryption_op(), Botan::Public_Key::create_encryption_op(), Botan::Private_Key::create_kem_decryption_op(), Botan::Public_Key::create_kem_encryption_op(), Botan::Private_Key::create_key_agreement_op(), Botan::Private_Key::create_signature_op(), Botan::Public_Key::create_verification_op(), Botan::Public_Key::get_oid(), Botan::TLS::Handshake_State::parse_sig_format(), Botan::PK_Decryptor_EME::PK_Decryptor_EME(), Botan::PK_Encryptor_EME::PK_Encryptor_EME(), Botan::PK_KEM_Decryptor::PK_KEM_Decryptor(), Botan::PK_KEM_Encryptor::PK_KEM_Encryptor(), Botan::PK_Key_Agreement::PK_Key_Agreement(), Botan::PK_Signer::PK_Signer(), Botan::PK_Verifier::PK_Verifier(), and Botan::verify_cert_constraints_valid_for_key_type().

std::string Botan::RSA_PublicKey::algo_name | ( |  | ) | const
| inline override virtual inherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 38 of file rsa.h.

Referenced by create_decryption_op(), Botan::RSA_PublicKey::create_encryption_op(), create_kem_decryption_op(), Botan::RSA_PublicKey::create_kem_encryption_op(), create_signature_op(), Botan::RSA_PublicKey::create_verification_op(), and RSA_PrivateKey().

38 { return "RSA"; }

AlgorithmIdentifier Botan::RSA_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 38 of file rsa.cpp.

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_NULL_PARAM.

39 {
40 return AlgorithmIdentifier(get_oid(),
41 AlgorithmIdentifier::USE_NULL_PARAM);
42 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:30
Botan::AlgorithmIdentifier::USE_NULL_PARAM
Definition: alg_id.h:23

virtual AlgorithmIdentifier Botan::Public_Key::algorithm_identifier | ( |  | ) | const
| pure virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implemented in Botan::XMSS_WOTS_PublicKey, Botan::XMSS_PublicKey, Botan::TPM_PrivateKey, Botan::EC_PublicKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::GOST_3410_PublicKey, Botan::RSA_PublicKey, Botan::McEliece_PublicKey, Botan::Curve25519_PublicKey, and Botan::DL_Scheme_PublicKey.

Referenced by Botan::choose_sig_format(), and Botan::Public_Key::subject_public_key().

bool Botan::RSA_PrivateKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Reimplemented from Botan::RSA_PublicKey.

Definition at line 161 of file rsa.cpp.

References Botan::inverse_mod(), Botan::BigInt::is_even(), Botan::is_prime(), Botan::lcm(), Botan::RSA_PublicKey::m_e, Botan::RSA_PublicKey::m_n, and Botan::KeyPair::signature_consistency_check().

162 {
163 if(m_n < 35 || m_n.is_even() || m_e < 2 || m_d < 2 || m_p < 3 || m_q < 3 || m_p*m_q != m_n)
164 return false;
165
166 if(m_d1 != m_d % (m_p - 1) || m_d2 != m_d % (m_q - 1) || m_c != inverse_mod(m_q, m_p))
167 return false;
168
169 const size_t prob = (strong) ? 128 : 12;
170
171 if(!is_prime(m_p, rng, prob) || !is_prime(m_q, rng, prob))
172 return false;
173
174 if(strong)
175 {
176 if((m_e * m_d) % lcm(m_p - 1, m_q - 1) != 1)
177 return false;
178
179 return KeyPair::signature_consistency_check(rng, *this, "EMSA4(SHA-256)");
180 }
181
182 return true;
183 }
Botan::BigInt::is_even
bool is_even() const
Definition: bigint.h:232
Botan::is_prime
bool is_prime(const BigInt &n, RandomNumberGenerator &rng, size_t prob, bool is_random)
Definition: numthry.cpp:441
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::KeyPair::signature_consistency_check
bool signature_consistency_check(RandomNumberGenerator &rng, const Private_Key &private_key, const Public_Key &public_key, const std::string &padding)
Definition: keypair.cpp:48
Botan::inverse_mod
BigInt inverse_mod(const BigInt &n, const BigInt &mod)
Definition: numthry.cpp:276
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76
Botan::lcm
BigInt lcm(const BigInt &a, const BigInt &b)
Definition: numthry.cpp:73

std::unique_ptr< PK_Ops::Decryption > Botan::RSA_PrivateKey::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 466 of file rsa.cpp.

References Botan::RSA_PublicKey::algo_name(), and Botan::Exception::what().

469 {
470 #if defined(BOTAN_HAS_OPENSSL)
471 if(provider == "openssl" || provider.empty())
472 {
473 try
474 {
475 return make_openssl_rsa_dec_op(*this, params);
476 }
477 catch(Exception& e)
478 {
479 if(provider == "openssl")
480 throw Exception("OpenSSL RSA provider rejected key:", e.what());
481 }
482 }
483 #endif
484
485 if(provider == "base" || provider.empty())
486 return std::unique_ptr<PK_Ops::Decryption>(new RSA_Decryption_Operation(*this, params, rng));
487
488 throw Provider_Not_Found(algo_name(), provider);
489 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::Encryption > Botan::RSA_PublicKey::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 407 of file rsa.cpp.

References Botan::RSA_PublicKey::algo_name(), and Botan::Exception::what().

410 {
411 #if defined(BOTAN_HAS_OPENSSL)
412 if(provider == "openssl" || provider.empty())
413 {
414 try
415 {
416 return make_openssl_rsa_enc_op(*this, params);
417 }
418 catch(Exception& e)
419 {
420 /*
421 * If OpenSSL for some reason could not handle this (eg due to OAEP params),
422 * throw if openssl was specifically requested but otherwise just fall back
423 * to the normal version.
424 */
425 if(provider == "openssl")
426 throw Exception("OpenSSL RSA provider rejected key:", e.what());
427 }
428 }
429 #endif
430
431 if(provider == "base" || provider.empty())
432 return std::unique_ptr<PK_Ops::Encryption>(new RSA_Encryption_Operation(*this, params));
433 throw Provider_Not_Found(algo_name(), provider);
434 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::ElGamal_PublicKey.

Definition at line 79 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

82 {
83 throw Lookup_Error(algo_name() + " does not support encryption");
84 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::RSA_PrivateKey::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 492 of file rsa.cpp.

References Botan::RSA_PublicKey::algo_name().

495 {
496 if(provider == "base" || provider.empty())
497 return std::unique_ptr<PK_Ops::KEM_Decryption>(new RSA_KEM_Decryption_Operation(*this, params, rng));
498
499 throw Provider_Not_Found(algo_name(), provider);
500 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::RSA_PublicKey::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 437 of file rsa.cpp.

References Botan::RSA_PublicKey::algo_name().

440 {
441 if(provider == "base" || provider.empty())
442 return std::unique_ptr<PK_Ops::KEM_Encryption>(new RSA_KEM_Encryption_Operation(*this, params));
443 throw Provider_Not_Found(algo_name(), provider);
444 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::McEliece_PublicKey.

Definition at line 87 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

90 {
91 throw Lookup_Error(algo_name() + " does not support KEM encryption");
92 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Key_Agreement > Botan::Private_Key::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ECDH_PrivateKey, Botan::Curve25519_PrivateKey, and Botan::DH_PrivateKey.

Definition at line 126 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Key_Agreement::PK_Key_Agreement().

129 {
130 throw Lookup_Error(algo_name() + " does not support key agreement");
131 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Signature > Botan::RSA_PrivateKey::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 503 of file rsa.cpp.

References Botan::RSA_PublicKey::algo_name().

506 {
507 #if defined(BOTAN_HAS_OPENSSL)
508 if(provider == "openssl" || provider.empty())
509 {
510 std::unique_ptr<PK_Ops::Signature> res = make_openssl_rsa_sig_op(*this, params);
511 if(res)
512 return res;
513 }
514 #endif
515
516 if(provider == "base" || provider.empty())
517 return std::unique_ptr<PK_Ops::Signature>(new RSA_Signature_Operation(*this, params, rng));
518
519 throw Provider_Not_Found(algo_name(), provider);
520 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::Verification > Botan::RSA_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 447 of file rsa.cpp.

References Botan::RSA_PublicKey::algo_name().

449 {
450 #if defined(BOTAN_HAS_OPENSSL)
451 if(provider == "openssl" || provider.empty())
452 {
453 std::unique_ptr<PK_Ops::Verification> res = make_openssl_rsa_ver_op(*this, params);
454 if(res)
455 return res;
456 }
457 #endif
458
459 if(provider == "base" || provider.empty())
460 return std::unique_ptr<PK_Ops::Verification>(new RSA_Verify_Operation(*this, params));
461
462 throw Provider_Not_Found(algo_name(), provider);
463 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::Verification > Botan::Public_Key::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_WOTS_PublicKey, Botan::XMSS_PublicKey, Botan::RSA_PublicKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 95 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Verifier::PK_Verifier().

97 {
98 throw Lookup_Error(algo_name() + " does not support verification");
99 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

virtual size_t Botan::Public_Key::estimated_strength | ( |  | ) | const
| pure virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implemented in Botan::XMSS_WOTS_PublicKey, Botan::XMSS_PublicKey, Botan::TPM_PrivateKey, Botan::EC_PublicKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::DL_Scheme_PublicKey, Botan::RSA_PublicKey, Botan::McEliece_PublicKey, and Botan::Curve25519_PublicKey.

Referenced by botan_pubkey_estimated_strength().

size_t Botan::RSA_PublicKey::estimated_strength | ( |  | ) | const
| override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 33 of file rsa.cpp.

References Botan::if_work_factor(), and Botan::RSA_PublicKey::key_length().

34 {
35 return if_work_factor(key_length());
36 }
Botan::RSA_PublicKey::key_length
size_t key_length() const override
Definition: rsa.cpp:28
Botan::if_work_factor
size_t if_work_factor(size_t bits)
Definition: workfactor.cpp:19

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg = `"SHA"` | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 57 of file pk_keys.cpp.

References Botan::HashFunction::create(), hash, Botan::hex_encode(), and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

58 {
59 secure_vector<uint8_t> buf = private_key_bits();
60 std::unique_ptr<HashFunction> hash(HashFunction::create(alg));
61 hash->update(buf);
62 const auto hex_print = hex_encode(hash->final());
63
64 std::string formatted_print;
65
66 for(size_t i = 0; i != hex_print.size(); i += 2)
67 {
68 formatted_print.push_back(hex_print[i]);
69 formatted_print.push_back(hex_print[i+1]);
70
71 if(i != hex_print.size() - 2)
72 formatted_print.push_back(':');
73 }
74
75 return formatted_print;
76 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::HashFunction::create
static std::unique_ptr< HashFunction > create(const std::string &algo_spec, const std::string &provider="")
Definition: hash.cpp:93
Botan::hex_encode
void hex_encode(char output[], const uint8_t input[], size_t input_length, bool uppercase)
Definition: hex.cpp:14
hash
MechanismType hash
Definition: p11_mechanism.cpp:63

const BigInt& Botan::RSA_PrivateKey::get_c | ( |  | ) | const
| inline

Definition at line 137 of file rsa.h.

References m_c.

137 { return m_c; }

const BigInt& Botan::RSA_PrivateKey::get_d | ( |  | ) | const
| inline

Get d with exp * d = 1 mod (p - 1, q - 1).

Returns
  d

Definition at line 135 of file rsa.h.

135 { return m_d; }

const BigInt& Botan::RSA_PrivateKey::get_d1 | ( |  | ) | const
| inline

Definition at line 138 of file rsa.h.

138 { return m_d1; }

const BigInt& Botan::RSA_PrivateKey::get_d2 | ( |  | ) | const
| inline

Definition at line 139 of file rsa.h.

139 { return m_d2; }

const BigInt& Botan::RSA_PublicKey::get_e | ( |  | ) | const
| inline inherited

Returns
  public exponent

Definition at line 54 of file rsa.h.

54 { return m_e; }
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76

const BigInt& Botan::RSA_PublicKey::get_n | ( |  | ) | const
| inline inherited

Returns
  public modulus

Definition at line 49 of file rsa.h.

References m_n.

49 { return m_n; }
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 30 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), and Botan::OIDS::lookup().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::TPM_PrivateKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

31 {
32 try {
33 return OIDS::lookup(algo_name());
34 }
35 catch(Lookup_Error&)
36 {
37 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
38 }
39 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:18

const BigInt& Botan::RSA_PrivateKey::get_p | ( |  | ) | const
| inline

Get the first prime p.

Returns
  prime p

Definition at line 123 of file rsa.h.

References m_p.

123 { return m_p; }

const BigInt& Botan::RSA_PrivateKey::get_q | ( |  | ) | const
| inline

Get the second prime q.

Returns
  prime q

Definition at line 129 of file rsa.h.

References m_q.

129 { return m_q; }

virtual size_t Botan::Public_Key::key_length | ( |  | ) | const
| pure virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implemented in Botan::XMSS_WOTS_PublicKey, Botan::XMSS_PublicKey, Botan::TPM_PrivateKey, Botan::EC_PublicKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::DL_Scheme_PublicKey, Botan::RSA_PublicKey, Botan::McEliece_PublicKey, and Botan::Curve25519_PublicKey.

Referenced by Botan::TLS::Policy::check_peer_key_acceptable().

size_t Botan::RSA_PublicKey::key_length | ( |  | ) | const
| override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 28 of file rsa.cpp.

References Botan::BigInt::bits(), and Botan::RSA_PublicKey::m_n.

Referenced by Botan::RSA_PublicKey::estimated_strength().

29 {
30 return m_n.bits();
31 }
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:184
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 114 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

114 { return 0; }

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 103 of file pk_keys.h.

Referenced by Botan::X509_Object::check_signature(), Botan::choose_sig_format(), Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

103 { return 1; }

virtual AlgorithmIdentifier Botan::Private_Key::pkcs8_algorithm_identifier | ( |  | ) | const
| inline virtual inherited

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented in Botan::XMSS_WOTS_PrivateKey, Botan::GOST_3410_PrivateKey, and Botan::XMSS_WOTS_Addressed_PrivateKey.

Definition at line 188 of file pk_keys.h.

Referenced by Botan::Private_Key::private_key_info().

189 { return algorithm_identifier(); }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0

secure_vector< uint8_t > Botan::RSA_PrivateKey::private_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 74 of file rsa.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::RSA_PublicKey::m_e, Botan::RSA_PublicKey::m_n, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

75 {
76 return DER_Encoder()
77 .start_cons(SEQUENCE)
78 .encode(static_cast<size_t>(0))
79 .encode(m_n)
80 .encode(m_e)
81 .encode(m_d)
82 .encode(m_p)
83 .encode(m_q)
84 .encode(m_d1)
85 .encode(m_d2)
86 .encode(m_c)
87 .end_cons()
88 .get_contents();
89 }
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 41 of file pk_keys.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

42 {
43 const size_t PKCS8_VERSION = 0;
44
45 return DER_Encoder()
46 .start_cons(SEQUENCE)
47 .encode(PKCS8_VERSION)
48 .encode(pkcs8_algorithm_identifier())
49 .encode(private_key_bits(), OCTET_STRING)
50 .end_cons()
51 .get_contents();
52 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::OCTET_STRING
Definition: asn1_obj.h:35
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:188
Botan::SEQUENCE
Definition: asn1_obj.h:39

std::vector< uint8_t > Botan::RSA_PublicKey::public_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 44 of file rsa.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents_unlocked(), Botan::RSA_PublicKey::m_e, Botan::RSA_PublicKey::m_n, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

45 {
46 return DER_Encoder()
47 .start_cons(SEQUENCE)
48 .encode(m_n)
49 .encode(m_e)
50 .end_cons()
51 .get_contents_unlocked();
52 }
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

virtual std::vector<uint8_t> Botan::Public_Key::public_key_bits | ( |  | ) | const
| pure virtual inherited

Returns
  BER encoded public key bits

Implemented in Botan::XMSS_WOTS_PublicKey, Botan::XMSS_PublicKey, Botan::TPM_PrivateKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::EC_PublicKey, Botan::GOST_3410_PublicKey, Botan::McEliece_PublicKey, Botan::RSA_PublicKey, Botan::Curve25519_PublicKey, and Botan::DL_Scheme_PublicKey.

Referenced by Botan::Public_Key::subject_public_key().

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 17 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents_unlocked(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), and Botan::X509::PEM_encode().

18 {
19 return DER_Encoder()
20 .start_cons(SEQUENCE)
21 .encode(algorithm_identifier())
22 .encode(public_key_bits(), BIT_STRING)
23 .end_cons()
24 .get_contents_unlocked();
25 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34

## Member Data Documentation

BigInt Botan::RSA_PublicKey::m_e
| protected inherited

Definition at line 76 of file rsa.h.

Referenced by Botan::RSA_PublicKey::check_key(), check_key(), private_key_bits(), Botan::RSA_PublicKey::public_key_bits(), RSA_PrivateKey(), and Botan::RSA_PublicKey::RSA_PublicKey().

BigInt Botan::RSA_PublicKey::m_n
| protected inherited

Definition at line 76 of file rsa.h.

Referenced by Botan::RSA_PublicKey::check_key(), check_key(), Botan::RSA_PublicKey::key_length(), private_key_bits(), Botan::RSA_PublicKey::public_key_bits(), RSA_PrivateKey(), and Botan::RSA_PublicKey::RSA_PublicKey().

The documentation for this class was generated from the following files:

- src/lib/pubkey/rsa/rsa.h
- src/lib/pubkey/rsa/rsa.cpp